org.apache.bcel.generic

## Class LDC

- java.lang.Object
- - org.apache.bcel.generic.Instruction
  - - org.apache.bcel.generic.CPInstruction
    - - org.apache.bcel.generic.LDC

- All Implemented Interfaces:
    Cloneable, ExceptionThrower, IndexedInstruction, PushInstruction, StackProducer, TypedInstruction
  Direct Known Subclasses:
    LDC_W

      public class LDC
      extends CPInstruction
      implements PushInstruction, ExceptionThrower

  LDC - Push item from constant pool.

      Stack: ... -> ..., item

  Version:
    $Id: LDC.java 1812166 2017-10-13 23:48:11Z ggregory $

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.generic.CPInstruction

      `index`

    - ### Fields inherited from class org.apache.bcel.generic.Instruction

      `length, opcode`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LDC(int index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Call corresponding visitor method(s).
    `void` | `dump(DataOutputStream out)` Dump instruction as byte code to stream out.
    `Class<?>[]` | `getExceptions()`
    `Type` | `getType(ConstantPoolGen cpg)`
    `Object` | `getValue(ConstantPoolGen cpg)`
    `protected void` | `initFromFile(ByteSequence bytes, boolean wide)` Read needed data (e.g.
    `void` | `setIndex(int index)` Set the index to constant pool and adjust size.
    `protected void` | `setSize()`

    - ### Methods inherited from class org.apache.bcel.generic.CPInstruction

      `getIndex, toString, toString`

    - ### Methods inherited from class org.apache.bcel.generic.Instruction

      `consumeStack, copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.bcel.generic.StackProducer

      `produceStack`

- - ### Constructor Detail

    - #### LDC

          public LDC(int index)

  - ### Method Detail

    - #### setSize

          protected final void setSize()

    - #### dump

          public void dump(DataOutputStream out)
                    throws IOException

      Dump instruction as byte code to stream out.
      Overrides:
        `dump` in class `CPInstruction`
      Parameters:
        `out` - Output stream
      Throws:
        `IOException`

    - #### setIndex

          public final void setIndex(int index)

      Set the index to constant pool and adjust size.
      Specified by:
        `setIndex` in interface `IndexedInstruction`
      Overrides:
        `setIndex` in class `CPInstruction`
      Parameters:
        `index` - in constant pool.

    - #### initFromFile

          protected void initFromFile(ByteSequence bytes,
                                      boolean wide)
                               throws IOException

      Read needed data (e.g. index) from file.
      Overrides:
        `initFromFile` in class `CPInstruction`
      Parameters:
        `bytes` - input stream
        `wide` - wide prefix?
      Throws:
        `IOException` - may be thrown if the implementation needs to read data from the file

    - #### getValue

          public Object getValue(ConstantPoolGen cpg)

    - #### getType

          public Type getType(ConstantPoolGen cpg)

      Specified by:
        `getType` in interface `TypedInstruction`
      Overrides:
        `getType` in class `CPInstruction`
      Returns:
        type related with this instruction.

    - #### getExceptions

          public Class<?>[] getExceptions()

      Specified by:
        `getExceptions` in interface `ExceptionThrower`

    - #### accept

          public void accept(Visitor v)

      Call corresponding visitor method(s). The order is: Call visitor methods of implemented interfaces first, then call methods according to the class hierarchy in descending order, i.e., the most specific visitXXX() call comes last.
      Specified by:
        `accept` in class `Instruction`
      Parameters:
        `v` - Visitor object

Copyright © 2004–2019 The Apache Software Foundation. All rights reserved.